Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 4901)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1)
@@ -2991,316 +2412,70 @@
        ENDIF
     ENDIF
-
 !
 !-- Check some other 1d-model parameters
-    IF ( TRIM( mixing_length_1d ) /= 'as_in_3d_model'  .AND.                                       &
+    IF ( TRIM( mixing_length_1d ) /= 'as_in_3d_model'  .AND. &
          TRIM( mixing_length_1d ) /= 'blackadar' )  THEN
-       message_string = 'mixing_length_1d = "' // TRIM( mixing_length_1d ) // '" is unknown'
-       CALL message( 'check_parameters', 'PA0137', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( TRIM( dissipation_1d ) /= 'as_in_3d_model'  .AND.                                         &
-         TRIM( dissipation_1d ) /= 'detering'        .AND.                                         &
-         TRIM( dissipation_1d ) /= 'prognostic' )  THEN
-       message_string = 'dissipation_1d = "' // TRIM( dissipation_1d ) // '" is unknown'
-       CALL message( 'check_parameters', 'PA0138', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( TRIM( mixing_length_1d ) /= 'as_in_3d_model'  .AND.                                       &
-         TRIM( dissipation_1d ) == 'as_in_3d_model' )  THEN
-       message_string = 'dissipation_1d = "' // TRIM( dissipation_1d ) //                          &
-                        '" requires mixing_length_1d = "as_in_3d_model"'
-       CALL message( 'check_parameters', 'PA0485', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Set time for the next user defined restart (time_restart is the internal parameter for steering
-!-- restart events)
-    IF ( restart_time /= 9999999.9_wp )  THEN
-       IF ( restart_time > time_since_reference_point )  THEN
-          time_restart = restart_time
-       ENDIF
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters: mixing_length_1d = "', &
+                                 TRIM( mixing_length_1d ), '" is unknown'
+       CALL local_stop
+    ENDIF
+    IF ( TRIM( dissipation_1d ) /= 'as_in_3d_model'  .AND. &
+         TRIM( dissipation_1d ) /= 'detering' )  THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters: dissipation_1d = "', &
+                                 TRIM( dissipation_1d ), '" is unknown'
+       CALL local_stop
+    ENDIF
+
+!
+!-- Set time for the next user defined restart (time_restart is the
+!-- internal parameter for steering restart events)
+    IF ( restart_time /= 9999999.9 )  THEN
+       IF ( restart_time > simulated_time )  time_restart = restart_time
     ELSE
 !
-!--    In case of a restart run, set internal parameter to default (no restart) if the
-!--    NAMELIST-parameter restart_time is omitted
-       time_restart = 9999999.9_wp
-    ENDIF
-
-!
-!-- Check pressure gradient conditions
-    IF ( dp_external  .AND.  conserve_volume_flow )  THEN
-       WRITE( message_string, * )  'Both dp_external and conserve_volume_flo',                     &
-              'w are .TRUE. but one of them must be .FALSE.'
-       CALL message( 'check_parameters', 'PA0150', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( dp_external )  THEN
-       IF ( dp_level_b < zu(nzb)  .OR.  dp_level_b > zu(nzt) )  THEN
-          WRITE( message_string, * )  'dp_level_b = ', dp_level_b, ' is out ',                     &
-                 ' of range [zu(nzb), zu(nzt)]'
-          CALL message( 'check_parameters', 'PA0151', 1, 2, 0, 6, 0 )
-       ENDIF
-       IF ( .NOT. ANY( dpdxy /= 0.0_wp ) )  THEN
-          WRITE( message_string, * )  'dp_external is .TRUE. but dpdxy is ze',                     &
-                 'ro, i.e. the external pressure gradient will not be applied'
-          CALL message( 'check_parameters', 'PA0152', 0, 1, 0, 6, 0 )
-       ENDIF
-    ENDIF
-    IF ( ANY( dpdxy /= 0.0_wp )  .AND.  .NOT.  dp_external )  THEN
-       WRITE( message_string, * )  'dpdxy is nonzero but dp_external is ',                         &
-              '.FALSE., i.e. the external pressure gradient & will not be applied'
-       CALL message( 'check_parameters', 'PA0153', 0, 1, 0, 6, 0 )
-    ENDIF
-    IF ( conserve_volume_flow )  THEN
-       IF ( TRIM( conserve_volume_flow_mode ) == 'default' )  THEN
-
-          conserve_volume_flow_mode = 'initial_profiles'
-
-       ELSEIF ( TRIM( conserve_volume_flow_mode ) /= 'initial_profiles'  .AND.                     &
-                TRIM( conserve_volume_flow_mode ) /= 'bulk_velocity' )  THEN
-          WRITE( message_string, * )  'unknown conserve_volume_flow_mode: ',                       &
-                 conserve_volume_flow_mode
-          CALL message( 'check_parameters', 'PA0154', 1, 2, 0, 6, 0 )
-       ENDIF
-       IF ( ( bc_lr /= 'cyclic'  .OR.  bc_ns /= 'cyclic')  .AND.                                   &
-            TRIM( conserve_volume_flow_mode ) == 'bulk_velocity' )  THEN
-          WRITE( message_string, * )  'non-cyclic boundary conditions ',                           &
-                 'require  conserve_volume_flow_mode = ''initial_profiles'''
-          CALL message( 'check_parameters', 'PA0155', 1, 2, 0, 6, 0 )
-       ENDIF
-    ENDIF
-    IF ( ( u_bulk /= 0.0_wp .OR. v_bulk /= 0.0_wp )  .AND.                                         &
-         ( .NOT. conserve_volume_flow .OR. TRIM( conserve_volume_flow_mode ) /= 'bulk_velocity' ) )&
-    THEN
-       WRITE( message_string, * )  'nonzero bulk velocity requires ',                              &
-              'conserve_volume_flow = .T. and ', 'conserve_volume_flow_mode = ''bulk_velocity'''
-       CALL message( 'check_parameters', 'PA0157', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Prevent empty time records in volume, cross-section and masked data in case of non-parallel
-!-- netcdf-output in restart runs
-    IF ( netcdf_data_format < 5 )  THEN
-       IF ( TRIM( initializing_actions ) == 'read_restart_data' )  THEN
-          do3d_time_count    = 0
-          do2d_xy_time_count = 0
-          do2d_xz_time_count = 0
-          do2d_yz_time_count = 0
-          domask_time_count  = 0
-       ENDIF
-    ENDIF
-
-
-!
-!-- Check roughness length, which has to be smaller than dz/2
-    IF ( ( constant_flux_layer .OR. INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  &
-         .AND.  roughness_length >= 0.5 * dz(1) )  THEN
-       message_string = 'roughness_length must be smaller than dz/2'
-       CALL message( 'check_parameters', 'PA0424', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Check if topography is read from file in case of complex terrain simulations
-    IF ( complex_terrain  .AND.  TRIM( topography ) /= 'read_from_file' )  THEN
-       message_string = 'complex_terrain requires topography = ''read_from_file'''
-       CALL message( 'check_parameters', 'PA0295', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Check if vertical grid stretching is switched off in case of complex terrain simulations
-    IF ( complex_terrain  .AND.  ANY( dz_stretch_level_start /= -9999999.9_wp ) )  THEN
-       message_string = 'Vertical grid stretching is not allowed for complex_terrain = .TRUE.'
-       CALL message( 'check_parameters', 'PA0473', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    CALL location_message( 'checking parameters', 'finished' )
-
- CONTAINS
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Check the length of data output intervals. In case of parallel NetCDF output the time levels of
-!> the output files need to be fixed. Therefore setting the output interval to 0.0s (usually used to
-!> output each timestep) is not possible as long as a non-fixed timestep is used.
-!--------------------------------------------------------------------------------------------------!
-
-    SUBROUTINE check_dt_do( dt_do, dt_do_name )
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*), INTENT (IN) :: dt_do_name !< parin variable name
-
-       REAL(wp), INTENT (INOUT)       :: dt_do      !< data output interval
-
-       IF ( dt_do == 0.0_wp )  THEN
-          IF ( dt_fixed )  THEN
-             WRITE( message_string, '(A,F9.4,A)' )  'Output at every timestep is wanted (' //      &
-                    dt_do_name // ' = 0.0).&'//                                                    &
-                    'The output interval is set to the fixed timestep dt '// '= ', dt, 's.'
-             CALL message( 'check_parameters', 'PA0060', 0, 0, 0, 6, 0 )
-             dt_do = dt
-          ELSE
-             message_string = dt_do_name // ' = 0.0 while using a ' //                             &
-                              'variable timestep and parallel netCDF4 is not allowed.'
-             CALL message( 'check_parameters', 'PA0081', 1, 2, 0, 6, 0 )
-          ENDIF
-       ENDIF
-
-    END SUBROUTINE check_dt_do
-
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Set the bottom and top boundary conditions for humidity and scalars.
-!--------------------------------------------------------------------------------------------------!
-
-    SUBROUTINE set_bc_scalars( sq, bc_b, bc_t, ibc_b, ibc_t, err_nr_b, err_nr_t )
-
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*)   ::  bc_b       !< bottom boundary condition
-       CHARACTER (LEN=*)   ::  bc_t       !< top boundary condition
-       CHARACTER (LEN=*)   ::  err_nr_b   !< error number if bottom bc is unknown
-       CHARACTER (LEN=*)   ::  err_nr_t   !< error number if top bc is unknown
-       CHARACTER (LEN=1)   ::  sq         !< name of scalar quantity
-
-
-       INTEGER(iwp)        ::  ibc_b      !< index for bottom boundary condition
-       INTEGER(iwp)        ::  ibc_t      !< index for top boundary condition
-
-!
-!--    Set Integer flags and check for possilbe errorneous settings for bottom boundary condition
-       IF ( bc_b == 'dirichlet' )  THEN
-          ibc_b = 0
-       ELSEIF ( bc_b == 'neumann' )  THEN
-          ibc_b = 1
+!--    In case of a restart run, set internal parameter to default (no restart)
+!--    if the NAMELIST-parameter restart_time is omitted
+       time_restart = 9999999.9
+    ENDIF
+
+!
+!-- Set default value of the time needed to terminate a model run
+    IF ( termination_time_needed == -1.0 )  THEN
+       IF ( host(1:3) == 'ibm' )  THEN
+          termination_time_needed = 300.0
        ELSE
-          message_string = 'unknown boundary condition: bc_' // TRIM( sq ) // '_b ="' //           &
-                           TRIM( bc_b ) // '"'
-          CALL message( 'check_parameters', err_nr_b, 1, 2, 0, 6, 0 )
-       ENDIF
-!
-!--    Set Integer flags and check for possilbe errorneous settings for top boundary condition
-       IF ( bc_t == 'dirichlet' )  THEN
-          ibc_t = 0
-       ELSEIF ( bc_t == 'neumann' )  THEN
-          ibc_t = 1
-       ELSEIF ( bc_t == 'initial_gradient' )  THEN
-          ibc_t = 2
-       ELSEIF ( bc_t == 'nested'  .OR.  bc_t == 'nesting_offline' )  THEN
-          ibc_t = 3
-       ELSE
-          message_string = 'unknown boundary condition: bc_' // TRIM( sq ) // '_t ="' //           &
-                           TRIM( bc_t ) // '"'
-          CALL message( 'check_parameters', err_nr_t, 1, 2, 0, 6, 0 )
-       ENDIF
-
-
-    END SUBROUTINE set_bc_scalars
-
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Check for consistent settings of bottom boundary conditions for humidity and scalars.
-!--------------------------------------------------------------------------------------------------!
-
-    SUBROUTINE check_bc_scalars( sq, bc_b, ibc_b, err_nr_1, err_nr_2, constant_flux,               &
-                                 surface_initial_change )
-
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*)   ::  bc_b                     !< bottom boundary condition
-       CHARACTER (LEN=*)   ::  err_nr_1                 !< error number of first error
-       CHARACTER (LEN=*)   ::  err_nr_2                 !< error number of second error
-       CHARACTER (LEN=1)   ::  sq                       !< name of scalar quantity
-
-
-       INTEGER(iwp)        ::  ibc_b                    !< index of bottom boundary condition
-
-       LOGICAL             ::  constant_flux            !< flag for constant-flux layer
-
-       REAL(wp)            ::  surface_initial_change   !< value of initial change at the surface
-
-!
-!--    A given surface value implies Dirichlet boundary condition for the respective quantity. In
-!--    this case specification of a constant flux is forbidden. However, an exception is made for
-!--    large-scale forcing as well as land-surface model.
-       IF ( .NOT. land_surface  .AND.  .NOT. large_scale_forcing )  THEN
-          IF ( ibc_b == 0  .AND.  constant_flux )  THEN
-             message_string = 'boundary condition: bc_' // TRIM( sq ) // '_b = "' //               &
-                              TRIM( bc_b ) // '" is not allowed with prescribed surface flux'
-             CALL message( 'check_parameters', err_nr_1, 1, 2, 0, 6, 0 )
-          ENDIF
-       ENDIF
-       IF ( constant_flux  .AND.  surface_initial_change /= 0.0_wp )  THEN
-          WRITE( message_string, * )  'a prescribed surface flux is not allo', 'wed with ', sq,    &
-                '_surface_initial_change (/=0) = ', surface_initial_change
-          CALL message( 'check_parameters', err_nr_2, 1, 2, 0, 6, 0 )
-       ENDIF
-
-
-    END SUBROUTINE check_bc_scalars
-
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Filter a list of strings for duplicates. The output list is of same length but does not contain
-!> any duplicates.
-!--------------------------------------------------------------------------------------------------!
-
-    SUBROUTINE filter_duplicate_strings( string_length, string_list, string_list_filtered )
-
-       IMPLICIT NONE
-
-       INTEGER, INTENT(IN) :: string_length  !< length of a single string in list
-
-       CHARACTER (LEN=*),             DIMENSION(:), INTENT(IN)               ::  string_list           !< non-filtered list
-       CHARACTER (LEN=string_length), DIMENSION(:), INTENT(OUT), ALLOCATABLE ::  string_list_filtered  !< filtered list
-
-       CHARACTER (LEN=string_length) ::  string_to_check  !< string to be check for duplicates
-
-       INTEGER(iwp) ::  i         !< loop index
-       INTEGER(iwp) ::  j         !< loop index
-       INTEGER(iwp) ::  k         !< loop index
-       INTEGER(iwp) ::  nstrings  !< number of strings in list
-
-       LOGICAL ::  is_duplicate  !< true if string has duplicates in list
-
-
-       nstrings = UBOUND( string_list, DIM=1 )
-       ALLOCATE( string_list_filtered(1:nstrings) )
-       string_list_filtered(:) = ' '
-
-       k = 0
-       DO  i = 1, nstrings
-          string_to_check = string_list(i)
-
-          IF ( string_to_check == ' ' )  EXIT
-
-          is_duplicate = .FALSE.
-          DO  j = 1, nstrings
-             IF ( string_list_filtered(j) == ' ' )  THEN
-                EXIT
-             ELSEIF ( string_to_check == string_list_filtered(j) )  THEN
-                is_duplicate = .TRUE.
-                EXIT
-             ENDIF
-          ENDDO
-
-          IF ( .NOT. is_duplicate )  THEN
-             k = k + 1
-             string_list_filtered(k) = string_to_check
-          ENDIF
-
-       ENDDO
-
-    END SUBROUTINE filter_duplicate_strings
+          termination_time_needed = 35.0
+       ENDIF
+    ENDIF
+
+!
+!-- Check the time needed to terminate a model run
+    IF ( host(1:3) == 't3e' )  THEN
+!
+!--    Time needed must be at least 30 seconds on all CRAY machines, because
+!--    MPP_TREMAIN gives the remaining CPU time only in steps of 30 seconds
+       IF ( termination_time_needed <= 30.0 )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*, '+++ check_parameters:  termination_time_needed', &
+                      termination_time_needed
+             PRINT*, '                       must be > 30.0 on host "', host, &
+                     '"'
+          ENDIF
+          CALL local_stop
+       ENDIF
+    ELSEIF ( host(1:3) == 'ibm' )  THEN
+!
+!--    On IBM-regatta machines the time should be at least 300 seconds,
+!--    because the job time consumed before executing palm (for compiling,
+!--    copying of files, etc.) has to be regarded
+       IF ( termination_time_needed < 300.0 )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*, '+++ WARNING: check_parameters:  termination_time_',  &
+                         'needed', termination_time_needed
+             PRINT*, '                                should be >= 300.0', &
+                         ' on host "', host, '"'
+          ENDIF
+       ENDIF
+    ENDIF
 
 
